From b51be901d7ffe0124b74eefc27531e99ec65feb4 Mon Sep 17 00:00:00 2001
From: Bharath Rupireddy <bharath.rupireddy@enterprisedb.com>
Date: Mon, 17 May 2021 12:07:35 +0530
Subject: [PATCH v1] Add TDE nonce bytes to page pd_special structure

Add TDE nonce bytes of size tde_nonce_size to page pd_special
structure while initializing the page in PageInit. For index pages,
MAXALIGN the nonce bytes with the existing structure i.e.
MAXALIGN(index_structure + nonce bytes). For heap pages, just
MAXALIGN(nonce bytes) and pd_special pointer points to nonce bytes.
The nonce value in the page will be store at the end of the page.

Since the nonce size is a run-time (initdb) option, some of the
macros were parameterized.
---
 contrib/amcheck/verify_heapam.c               | 12 +++--
 contrib/amcheck/verify_nbtree.c               |  8 +--
 contrib/bloom/bloom.h                         | 26 ++++++----
 contrib/bloom/blutils.c                       | 11 ++--
 contrib/bloom/blvacuum.c                      |  4 +-
 contrib/hstore/hstore_gist.c                  |  3 +-
 contrib/intarray/_int.h                       |  5 +-
 contrib/ltree/ltree.h                         |  4 +-
 contrib/pageinspect/brinfuncs.c               |  2 +-
 contrib/pageinspect/fsmfuncs.c                |  2 +-
 contrib/pageinspect/ginfuncs.c                |  6 ++-
 contrib/pageinspect/hashfuncs.c               |  3 +-
 contrib/pg_surgery/heap_surgery.c             |  4 +-
 contrib/pg_trgm/trgm.h                        |  3 +-
 contrib/pgstattuple/pgstatapprox.c            |  3 +-
 contrib/pgstattuple/pgstatindex.c             |  2 +-
 contrib/pgstattuple/pgstattuple.c             |  3 +-
 src/backend/access/brin/brin_bloom.c          | 14 ++---
 src/backend/access/brin/brin_minmax_multi.c   | 14 ++---
 src/backend/access/brin/brin_pageops.c        | 19 ++++---
 src/backend/access/brin/brin_revmap.c         | 22 ++++----
 src/backend/access/brin/brin_tuple.c          |  3 +-
 src/backend/access/common/indextuple.c        |  3 +-
 src/backend/access/common/reloptions.c        | 10 +++-
 src/backend/access/common/toast_internals.c   |  4 +-
 src/backend/access/gin/gindatapage.c          | 41 +++++++--------
 src/backend/access/gin/ginentrypage.c         |  4 +-
 src/backend/access/gin/ginfast.c              | 13 +++--
 src/backend/access/gin/gininsert.c            |  7 ++-
 src/backend/access/gin/ginvacuum.c            |  4 +-
 src/backend/access/gin/ginxlog.c              |  6 +--
 src/backend/access/gist/gist.c                |  4 +-
 src/backend/access/gist/gistbuild.c           |  2 +
 src/backend/access/gist/gistget.c             |  8 +--
 src/backend/access/gist/gistutil.c            |  5 +-
 src/backend/access/hash/hash.c                |  4 +-
 src/backend/access/hash/hashinsert.c          |  4 +-
 src/backend/access/hash/hashovfl.c            |  6 +--
 src/backend/access/hash/hashpage.c            |  6 +--
 src/backend/access/hash/hashsearch.c          | 10 ++--
 src/backend/access/hash/hashutil.c            |  4 +-
 src/backend/access/heap/heapam.c              | 19 +++----
 src/backend/access/heap/heapam_handler.c      | 16 +++---
 src/backend/access/heap/heaptoast.c           | 27 ++++++----
 src/backend/access/heap/hio.c                 |  8 +--
 src/backend/access/heap/pruneheap.c           | 18 +++----
 src/backend/access/heap/rewriteheap.c         |  7 +--
 src/backend/access/heap/vacuumlazy.c          | 19 +++----
 src/backend/access/heap/visibilitymap.c       | 42 ++++++++-------
 src/backend/access/nbtree/nbtdedup.c          |  4 +-
 src/backend/access/nbtree/nbtinsert.c         |  4 +-
 src/backend/access/nbtree/nbtpage.c           | 11 ++--
 src/backend/access/nbtree/nbtree.c            |  4 +-
 src/backend/access/nbtree/nbtsort.c           |  5 +-
 src/backend/access/nbtree/nbtsplitloc.c       |  2 +-
 src/backend/access/nbtree/nbtutils.c          |  8 +--
 src/backend/access/nbtree/nbtxlog.c           |  6 +--
 src/backend/access/spgist/spgdoinsert.c       | 28 +++++-----
 src/backend/access/spgist/spgscan.c           |  2 +-
 src/backend/access/spgist/spgutils.c          |  8 +--
 src/backend/access/spgist/spgvacuum.c         | 22 ++++----
 src/backend/access/transam/xlog.c             |  6 +--
 src/backend/nodes/tidbitmap.c                 | 23 +++++----
 .../replication/logical/reorderbuffer.c       |  2 +-
 src/backend/storage/freespace/freespace.c     | 51 +++++++++++--------
 src/backend/storage/freespace/fsmpage.c       | 21 ++++----
 src/backend/storage/page/bufpage.c            | 25 ++++++---
 src/backend/utils/adt/selfuncs.c              |  2 +-
 src/backend/utils/adt/tsgistidx.c             |  4 +-
 src/bin/pg_resetwal/pg_resetwal.c             |  4 +-
 src/include/access/brin_page.h                |  8 +--
 src/include/access/ginblock.h                 | 22 ++++----
 src/include/access/gist.h                     |  9 ++--
 src/include/access/gist_private.h             |  6 ++-
 src/include/access/hash.h                     | 11 ++--
 src/include/access/heapam.h                   |  2 +-
 src/include/access/heaptoast.h                | 39 +++++++++++---
 src/include/access/htup_details.h             | 12 ++++-
 src/include/access/itup.h                     |  5 +-
 src/include/access/nbtree.h                   | 10 ++--
 src/include/access/spgist_private.h           | 14 ++---
 src/include/storage/fsm_internals.h           |  7 +--
 .../test_ginpostinglist/test_ginpostinglist.c |  6 +--
 83 files changed, 505 insertions(+), 362 deletions(-)

diff --git a/contrib/amcheck/verify_heapam.c b/contrib/amcheck/verify_heapam.c
index d8b3fd3d4f..94f5a66012 100644
--- a/contrib/amcheck/verify_heapam.c
+++ b/contrib/amcheck/verify_heapam.c
@@ -1179,12 +1179,14 @@ check_toast_tuple(HeapTuple toasttup, HeapCheckContext *ctx,
 				  uint32 extsize)
 {
 	int32		chunk_seq;
-	int32		last_chunk_seq = (extsize - 1) / TOAST_MAX_CHUNK_SIZE;
+	int32		last_chunk_seq;
 	Pointer		chunk;
 	bool		isnull;
 	int32		chunksize;
 	int32		expected_size;
 
+	last_chunk_seq = (extsize - 1) / TOAST_MAX_CHUNK_SIZE(tde_nonce_size);
+
 	/* Sanity-check the sequence number. */
 	chunk_seq = DatumGetInt32(fastgetattr(toasttup, 2,
 										  ctx->toast_rel->rd_att, &isnull));
@@ -1249,8 +1251,10 @@ check_toast_tuple(HeapTuple toasttup, HeapCheckContext *ctx,
 		return;
 	}
 
-	expected_size = chunk_seq < last_chunk_seq ? TOAST_MAX_CHUNK_SIZE
-		: extsize - (last_chunk_seq * TOAST_MAX_CHUNK_SIZE);
+	if (chunk_seq < last_chunk_seq)
+		expected_size = TOAST_MAX_CHUNK_SIZE(tde_nonce_size);
+	else
+		expected_size = extsize - (last_chunk_seq * TOAST_MAX_CHUNK_SIZE(tde_nonce_size));
 
 	if (chunksize != expected_size)
 		report_toast_corruption(ctx, ta,
@@ -1457,7 +1461,7 @@ check_toasted_attribute(HeapCheckContext *ctx, ToastedAttribute *ta)
 	int32		last_chunk_seq;
 
 	extsize = VARATT_EXTERNAL_GET_EXTSIZE(ta->toast_pointer);
-	last_chunk_seq = (extsize - 1) / TOAST_MAX_CHUNK_SIZE;
+	last_chunk_seq = (extsize - 1) / TOAST_MAX_CHUNK_SIZE(tde_nonce_size);
 
 	/*
 	 * Setup a scan key to find chunks in toast table with matching va_valueid
diff --git a/contrib/amcheck/verify_nbtree.c b/contrib/amcheck/verify_nbtree.c
index fdfc320e84..fc2b28832b 100644
--- a/contrib/amcheck/verify_nbtree.c
+++ b/contrib/amcheck/verify_nbtree.c
@@ -1257,8 +1257,8 @@ bt_target_page_check(BtreeCheckState *state)
 		 */
 		lowersizelimit = skey->heapkeyspace &&
 			(P_ISLEAF(topaque) || BTreeTupleGetHeapTID(itup) == NULL);
-		if (tupsize > (lowersizelimit ? BTMaxItemSize(state->target) :
-					   BTMaxItemSizeNoHeapTid(state->target)))
+		if (tupsize > (lowersizelimit ? BTMaxItemSize(state->target, tde_nonce_size) :
+					   BTMaxItemSizeNoHeapTid(state->target, tde_nonce_size)))
 		{
 			ItemPointer tid = BTreeTupleGetPointsToTID(itup);
 			char	   *itid,
@@ -3031,12 +3031,12 @@ palloc_btree_page(BtreeCheckState *state, BlockNumber blocknum)
 	 * to move left, in the case of backward index scans).
 	 */
 	maxoffset = PageGetMaxOffsetNumber(page);
-	if (maxoffset > MaxIndexTuplesPerPage)
+	if (maxoffset > MaxIndexTuplesPerPage(tde_nonce_size))
 		ereport(ERROR,
 				(errcode(ERRCODE_INDEX_CORRUPTED),
 				 errmsg("Number of items on block %u of index \"%s\" exceeds MaxIndexTuplesPerPage (%u)",
 						blocknum, RelationGetRelationName(state->rel),
-						MaxIndexTuplesPerPage)));
+						MaxIndexTuplesPerPage(tde_nonce_size))));
 
 	if (!P_ISLEAF(opaque) && !P_ISDELETED(opaque) && maxoffset < P_FIRSTDATAKEY(opaque))
 		ereport(ERROR,
diff --git a/contrib/bloom/bloom.h b/contrib/bloom/bloom.h
index a22a6dfa40..fa4cdf01c4 100644
--- a/contrib/bloom/bloom.h
+++ b/contrib/bloom/bloom.h
@@ -97,6 +97,18 @@ typedef uint16 BloomSignatureWord;
 #define DEFAULT_BLOOM_BITS		2
 #define MAX_BLOOM_BITS			(MAX_BLOOM_LENGTH - 1)
 
+#define FREE_BLK_NUM_ARRAY_MAX_SIZE     MAXALIGN_DOWN(BLCKSZ - SizeOfPageHeaderData - \
+													  MAXALIGN(sizeof(BloomPageOpaqueData)) - \
+													  MAXALIGN(sizeof(uint16) * 2 + \
+													  sizeof(uint32) + sizeof(BloomOptions))) \
+													  / sizeof(BlockNumber)
+
+#define FREE_BLK_NUM_ARRAY_SIZE(tdeNonceSize)	MAXALIGN_DOWN(BLCKSZ - SizeOfPageHeaderData - \
+													  MAXALIGN(sizeof(BloomPageOpaqueData) + \
+													  tdeNonceSize) - \
+													  MAXALIGN(sizeof(uint16) * 2 + \
+													  sizeof(uint32) + sizeof(BloomOptions))) \
+													  / sizeof(BlockNumber)
 /* Bloom index options */
 typedef struct BloomOptions
 {
@@ -110,12 +122,7 @@ typedef struct BloomOptions
  * FreeBlockNumberArray - array of block numbers sized so that metadata fill
  * all space in metapage.
  */
-typedef BlockNumber FreeBlockNumberArray[
-										 MAXALIGN_DOWN(
-													   BLCKSZ - SizeOfPageHeaderData - MAXALIGN(sizeof(BloomPageOpaqueData))
-													   - MAXALIGN(sizeof(uint16) * 2 + sizeof(uint32) + sizeof(BloomOptions))
-													   ) / sizeof(BlockNumber)
-];
+typedef BlockNumber FreeBlockNumberArray[FREE_BLK_NUM_ARRAY_MAX_SIZE];
 
 /* Metadata of bloom index */
 typedef struct BloomMetaPageData
@@ -131,7 +138,8 @@ typedef struct BloomMetaPageData
 #define BLOOM_MAGICK_NUMBER (0xDBAC0DED)
 
 /* Number of blocks numbers fit in BloomMetaPageData */
-#define BloomMetaBlockN		(sizeof(FreeBlockNumberArray) / sizeof(BlockNumber))
+#define BloomMetaBlockN(tdeNonceSize)	((sizeof(BlockNumber) * FREE_BLK_NUM_ARRAY_SIZE(tdeNonceSize)) \
+										/ sizeof(BlockNumber))
 
 #define BloomPageGetMeta(page)	((BloomMetaPageData *) PageGetContents(page))
 
@@ -149,10 +157,10 @@ typedef struct BloomState
 	Size		sizeOfBloomTuple;
 } BloomState;
 
-#define BloomPageGetFreeSpace(state, page) \
+#define BloomPageGetFreeSpace(state, page, tdeNonceSize) \
 	(BLCKSZ - MAXALIGN(SizeOfPageHeaderData) \
 		- BloomPageGetMaxOffset(page) * (state)->sizeOfBloomTuple \
-		- MAXALIGN(sizeof(BloomPageOpaqueData)))
+		- MAXALIGN(sizeof(BloomPageOpaqueData) + tdeNonceSize))
 
 /*
  * Tuples are very different from all other relations
diff --git a/contrib/bloom/blutils.c b/contrib/bloom/blutils.c
index 754de008d4..b79bf90cbf 100644
--- a/contrib/bloom/blutils.c
+++ b/contrib/bloom/blutils.c
@@ -325,7 +325,7 @@ BloomPageAddItem(BloomState *state, Page page, BloomTuple *tuple)
 	Assert(!PageIsNew(page) && !BloomPageIsDeleted(page));
 
 	/* Does new tuple fit on the page? */
-	if (BloomPageGetFreeSpace(state, page) < state->sizeOfBloomTuple)
+	if (BloomPageGetFreeSpace(state, page, tde_nonce_size) < state->sizeOfBloomTuple)
 		return false;
 
 	/* Copy new tuple to the end of page */
@@ -423,6 +423,11 @@ BloomFillMetapage(Relation index, Page metaPage)
 {
 	BloomOptions *opts;
 	BloomMetaPageData *metadata;
+	Size sz;
+
+	/* Size of the actual BloomMetaPageData */
+	sz = sizeof(BloomMetaPageData) - sizeof(FreeBlockNumberArray) +
+		 sizeof(BlockNumber) * FREE_BLK_NUM_ARRAY_SIZE(tde_nonce_size);
 
 	/*
 	 * Choose the index's options.  If reloptions have been assigned, use
@@ -438,10 +443,10 @@ BloomFillMetapage(Relation index, Page metaPage)
 	 */
 	BloomInitPage(metaPage, BLOOM_META);
 	metadata = BloomPageGetMeta(metaPage);
-	memset(metadata, 0, sizeof(BloomMetaPageData));
+	memset(metadata, 0, sz);
 	metadata->magickNumber = BLOOM_MAGICK_NUMBER;
 	metadata->opts = *opts;
-	((PageHeader) metaPage)->pd_lower += sizeof(BloomMetaPageData);
+	((PageHeader) metaPage)->pd_lower += sz;
 
 	/* If this fails, probably FreeBlockNumberArray size calc is wrong: */
 	Assert(((PageHeader) metaPage)->pd_lower <= ((PageHeader) metaPage)->pd_upper);
diff --git a/contrib/bloom/blvacuum.c b/contrib/bloom/blvacuum.c
index 88b0a6d290..6621128c2d 100644
--- a/contrib/bloom/blvacuum.c
+++ b/contrib/bloom/blvacuum.c
@@ -115,8 +115,8 @@ blbulkdelete(IndexVacuumInfo *info, IndexBulkDeleteResult *stats,
 		 * deleted and there is free space on it
 		 */
 		if (BloomPageGetMaxOffset(page) != 0 &&
-			BloomPageGetFreeSpace(&state, page) >= state.sizeOfBloomTuple &&
-			countPage < BloomMetaBlockN)
+			BloomPageGetFreeSpace(&state, page, tde_nonce_size) >= state.sizeOfBloomTuple &&
+			countPage < BloomMetaBlockN(tde_nonce_size))
 			notFullPage[countPage++] = blkno;
 
 		/* Did we delete something? */
diff --git a/contrib/hstore/hstore_gist.c b/contrib/hstore/hstore_gist.c
index 102c9cea72..52c1f1f62f 100644
--- a/contrib/hstore/hstore_gist.c
+++ b/contrib/hstore/hstore_gist.c
@@ -8,6 +8,7 @@
 #include "access/stratnum.h"
 #include "catalog/pg_type.h"
 #include "hstore.h"
+#include "miscadmin.h" /* for tde_nonce_size */
 #include "utils/pg_crc.h"
 
 /* gist_hstore_ops opclass options */
@@ -20,7 +21,7 @@ typedef struct
 /* bigint defines */
 #define BITBYTE 8
 #define SIGLEN_DEFAULT	(sizeof(int32) * 4)
-#define SIGLEN_MAX		GISTMaxIndexKeySize
+#define SIGLEN_MAX		GISTMaxIndexKeySize(tde_nonce_size)
 #define SIGLENBIT(siglen) ((siglen) * BITBYTE)
 #define GET_SIGLEN()	(PG_HAS_OPCLASS_OPTIONS() ? \
 						 ((GistHstoreOptions *) PG_GET_OPCLASS_OPTIONS())->siglen : \
diff --git a/contrib/intarray/_int.h b/contrib/intarray/_int.h
index 304c29525c..63089bf100 100644
--- a/contrib/intarray/_int.h
+++ b/contrib/intarray/_int.h
@@ -4,12 +4,13 @@
 #ifndef ___INT_H__
 #define ___INT_H__
 
+#include "miscadmin.h" /* for tde_nonce_size */
 #include "utils/array.h"
 #include "utils/memutils.h"
 
 /* number ranges for compression */
 #define G_INT_NUMRANGES_DEFAULT		100
-#define G_INT_NUMRANGES_MAX			((GISTMaxIndexKeySize - VARHDRSZ) / \
+#define G_INT_NUMRANGES_MAX			((GISTMaxIndexKeySize(tde_nonce_size) - VARHDRSZ) / \
 									 (2 * sizeof(int32)))
 #define G_INT_GET_NUMRANGES()		(PG_HAS_OPCLASS_OPTIONS() ? \
 									 ((GISTIntArrayOptions *) PG_GET_OPCLASS_OPTIONS())->num_ranges : \
@@ -60,7 +61,7 @@ typedef struct
 
 /* bigint defines */
 #define SIGLEN_DEFAULT		(63 * 4)
-#define SIGLEN_MAX			GISTMaxIndexKeySize
+#define SIGLEN_MAX			GISTMaxIndexKeySize(tde_nonce_size)
 #define SIGLENBIT(siglen)	((siglen) * BITS_PER_BYTE)
 #define GET_SIGLEN()		(PG_HAS_OPCLASS_OPTIONS() ? \
 							 ((GISTIntArrayBigOptions *) PG_GET_OPCLASS_OPTIONS())->siglen : \
diff --git a/contrib/ltree/ltree.h b/contrib/ltree/ltree.h
index dc68a0c212..b1121a707e 100644
--- a/contrib/ltree/ltree.h
+++ b/contrib/ltree/ltree.h
@@ -216,7 +216,7 @@ int			ltree_strncasecmp(const char *a, const char *b, size_t s);
 
 /* GiST support for ltree */
 
-#define SIGLEN_MAX		GISTMaxIndexKeySize
+#define SIGLEN_MAX		GISTMaxIndexKeySize(tde_nonce_size)
 #define SIGLEN_DEFAULT	(2 * sizeof(int32))
 #define BITBYTE 8
 #define SIGLEN	(sizeof(int32) * SIGLENINT)
@@ -277,7 +277,7 @@ extern ltree_gist *ltree_gist_alloc(bool isalltrue, BITVECP sign, int siglen,
 /* GiST support for ltree[] */
 
 #define LTREE_ASIGLEN_DEFAULT	(7 * sizeof(int32))
-#define LTREE_ASIGLEN_MAX		GISTMaxIndexKeySize
+#define LTREE_ASIGLEN_MAX		GISTMaxIndexKeySize(tde_nonce_size)
 #define LTREE_GET_ASIGLEN()		(PG_HAS_OPCLASS_OPTIONS() ? \
 								 ((LtreeGistOptions *) PG_GET_OPCLASS_OPTIONS())->siglen : \
 								 LTREE_ASIGLEN_DEFAULT)
diff --git a/contrib/pageinspect/brinfuncs.c b/contrib/pageinspect/brinfuncs.c
index 0e3c2deb66..4a212cfbbb 100644
--- a/contrib/pageinspect/brinfuncs.c
+++ b/contrib/pageinspect/brinfuncs.c
@@ -414,7 +414,7 @@ brin_revmap_data(PG_FUNCTION_ARGS)
 	fctx = SRF_PERCALL_SETUP();
 	state = fctx->user_fctx;
 
-	if (state->idx < REVMAP_PAGE_MAXITEMS)
+	if (state->idx < REVMAP_PAGE_MAXITEMS(tde_nonce_size))
 		SRF_RETURN_NEXT(fctx, PointerGetDatum(&state->tids[state->idx++]));
 
 	SRF_RETURN_DONE(fctx);
diff --git a/contrib/pageinspect/fsmfuncs.c b/contrib/pageinspect/fsmfuncs.c
index 930f1df339..37f0a9a75a 100644
--- a/contrib/pageinspect/fsmfuncs.c
+++ b/contrib/pageinspect/fsmfuncs.c
@@ -48,7 +48,7 @@ fsm_page_contents(PG_FUNCTION_ARGS)
 
 	initStringInfo(&sinfo);
 
-	for (i = 0; i < NodesPerPage; i++)
+	for (i = 0; i < NodesPerPage(tde_nonce_size); i++)
 	{
 		if (fsmpage->fp_nodes[i] != 0)
 			appendStringInfo(&sinfo, "%d: %d\n", i, fsmpage->fp_nodes[i]);
diff --git a/contrib/pageinspect/ginfuncs.c b/contrib/pageinspect/ginfuncs.c
index e425cbcdb8..451f67a3e8 100644
--- a/contrib/pageinspect/ginfuncs.c
+++ b/contrib/pageinspect/ginfuncs.c
@@ -184,13 +184,15 @@ gin_leafpage_items(PG_FUNCTION_ARGS)
 
 		page = get_page_from_raw(raw_page);
 
-		if (PageGetSpecialSize(page) != MAXALIGN(sizeof(GinPageOpaqueData)))
+		if (PageGetSpecialSize(page) !=
+			MAXALIGN(sizeof(GinPageOpaqueData) + tde_nonce_size))
 			ereport(ERROR,
 					(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
 					 errmsg("input page is not a valid GIN data leaf page"),
 					 errdetail("Special size %d, expected %d",
 							   (int) PageGetSpecialSize(page),
-							   (int) MAXALIGN(sizeof(GinPageOpaqueData)))));
+							   (int) MAXALIGN(sizeof(GinPageOpaqueData) +
+									 tde_nonce_size))));
 
 		opaq = (GinPageOpaque) PageGetSpecialPointer(page);
 		if (opaq->flags != (GIN_DATA | GIN_LEAF | GIN_COMPRESSED))
diff --git a/contrib/pageinspect/hashfuncs.c b/contrib/pageinspect/hashfuncs.c
index ff01119474..25e3717a0a 100644
--- a/contrib/pageinspect/hashfuncs.c
+++ b/contrib/pageinspect/hashfuncs.c
@@ -64,7 +64,8 @@ verify_hash_page(bytea *raw_page, int flags)
 	{
 		HashPageOpaque pageopaque;
 
-		if (PageGetSpecialSize(page) != MAXALIGN(sizeof(HashPageOpaqueData)))
+		if (PageGetSpecialSize(page) !=
+			MAXALIGN(sizeof(HashPageOpaqueData) + tde_nonce_size))
 			ereport(ERROR,
 					(errcode(ERRCODE_INDEX_CORRUPTED),
 					 errmsg("index table contains corrupted page")));
diff --git a/contrib/pg_surgery/heap_surgery.c b/contrib/pg_surgery/heap_surgery.c
index d31e5f31fd..e718100324 100644
--- a/contrib/pg_surgery/heap_surgery.c
+++ b/contrib/pg_surgery/heap_surgery.c
@@ -88,7 +88,7 @@ heap_force_common(FunctionCallInfo fcinfo, HeapTupleForceOption heap_force_opt)
 	Relation	rel;
 	OffsetNumber curr_start_ptr,
 				next_start_ptr;
-	bool		include_this_tid[MaxHeapTuplesPerPage];
+	bool		include_this_tid[MaxHeapTuplesPerPageLimit];
 
 	if (RecoveryInProgress())
 		ereport(ERROR,
@@ -206,7 +206,7 @@ heap_force_common(FunctionCallInfo fcinfo, HeapTupleForceOption heap_force_opt)
 			}
 
 			/* Mark it for processing. */
-			Assert(offno < MaxHeapTuplesPerPage);
+			Assert(offno < MaxHeapTuplesPerPage(tde_nonce_size));
 			include_this_tid[offno] = true;
 		}
 
diff --git a/contrib/pg_trgm/trgm.h b/contrib/pg_trgm/trgm.h
index 405a1d9552..a1c1c9fb84 100644
--- a/contrib/pg_trgm/trgm.h
+++ b/contrib/pg_trgm/trgm.h
@@ -7,6 +7,7 @@
 #include "access/gist.h"
 #include "access/itup.h"
 #include "access/stratnum.h"
+#include "miscadmin.h" /* for tde_nonce_size */
 #include "storage/bufpage.h"
 
 /*
@@ -75,7 +76,7 @@ typedef struct
 
 /* gist */
 #define SIGLEN_DEFAULT	(sizeof(int) * 3)
-#define SIGLEN_MAX		GISTMaxIndexKeySize
+#define SIGLEN_MAX		GISTMaxIndexKeySize(tde_nonce_size)
 #define BITBYTE 8
 
 #define SIGLENBIT(siglen) ((siglen) * BITBYTE - 1)	/* see makesign */
diff --git a/contrib/pgstattuple/pgstatapprox.c b/contrib/pgstattuple/pgstatapprox.c
index 1fe193bb25..745fc25b8b 100644
--- a/contrib/pgstattuple/pgstatapprox.c
+++ b/contrib/pgstattuple/pgstatapprox.c
@@ -113,7 +113,8 @@ statapprox_heap(Relation rel, output_type *stat)
 		if (!PageIsNew(page))
 			stat->free_space += PageGetHeapFreeSpace(page);
 		else
-			stat->free_space += BLCKSZ - SizeOfPageHeaderData;
+			stat->free_space += BLCKSZ - SizeOfPageHeaderData -
+								MAXALIGN(tde_nonce_size);
 
 		/* We may count the page as scanned even if it's new/empty */
 		scanned++;
diff --git a/contrib/pgstattuple/pgstatindex.c b/contrib/pgstattuple/pgstatindex.c
index 5368bb30f0..0405753ce7 100644
--- a/contrib/pgstattuple/pgstatindex.c
+++ b/contrib/pgstattuple/pgstatindex.c
@@ -649,7 +649,7 @@ pgstathashindex(PG_FUNCTION_ARGS)
 		if (PageIsNew(page))
 			stats.unused_pages++;
 		else if (PageGetSpecialSize(page) !=
-				 MAXALIGN(sizeof(HashPageOpaqueData)))
+				 MAXALIGN(sizeof(HashPageOpaqueData) + tde_nonce_size))
 			ereport(ERROR,
 					(errcode(ERRCODE_INDEX_CORRUPTED),
 					 errmsg("index \"%s\" contains corrupted page at block %u",
diff --git a/contrib/pgstattuple/pgstattuple.c b/contrib/pgstattuple/pgstattuple.c
index 21fdeff8af..4acec7f6e3 100644
--- a/contrib/pgstattuple/pgstattuple.c
+++ b/contrib/pgstattuple/pgstattuple.c
@@ -460,7 +460,8 @@ pgstat_hash_page(pgstattuple_type *stat, Relation rel, BlockNumber blkno,
 	buf = _hash_getbuf_with_strategy(rel, blkno, HASH_READ, 0, bstrategy);
 	page = BufferGetPage(buf);
 
-	if (PageGetSpecialSize(page) == MAXALIGN(sizeof(HashPageOpaqueData)))
+	if (PageGetSpecialSize(page) ==
+		MAXALIGN(sizeof(HashPageOpaqueData) + tde_nonce_size))
 	{
 		HashPageOpaque opaque;
 
diff --git a/src/backend/access/brin/brin_bloom.c b/src/backend/access/brin/brin_bloom.c
index 99b2543f76..6d13416b50 100644
--- a/src/backend/access/brin/brin_bloom.c
+++ b/src/backend/access/brin/brin_bloom.c
@@ -125,6 +125,7 @@
 #include "access/stratnum.h"
 #include "catalog/pg_type.h"
 #include "catalog/pg_amop.h"
+#include "miscadmin.h" /* for tde_nonce_size */
 #include "utils/builtins.h"
 #include "utils/datum.h"
 #include "utils/lsyscache.h"
@@ -211,11 +212,10 @@ typedef struct BloomOptions
  * a perfect guarantee, for a couple of reasons. For example, the row may
  * be larger because the index has multiple columns.
  */
-#define BloomMaxFilterSize \
+#define BloomMaxFilterSize(tdeNonceSize) \
 	MAXALIGN_DOWN(BLCKSZ - \
-				  (MAXALIGN(SizeOfPageHeaderData + \
-							sizeof(ItemIdData)) + \
-				   MAXALIGN(sizeof(BrinSpecialSpace)) + \
+				  (MAXALIGN(SizeOfPageHeaderData + sizeof(ItemIdData)) + \
+				   MAXALIGN(sizeof(BrinSpecialSpace) + tdeNonceSize) + \
 				   SizeOfBrinTuple))
 
 /*
@@ -307,9 +307,9 @@ bloom_init(int ndistinct, double false_positive_rate)
 	 * XXX This check is not perfect, because the index may have multiple
 	 * filters that are small individually, but too large when combined.
 	 */
-	if (nbytes > BloomMaxFilterSize)
+	if (nbytes > BloomMaxFilterSize(tde_nonce_size))
 		elog(ERROR, "the bloom filter is too large (%d > %zu)", nbytes,
-			 BloomMaxFilterSize);
+			 BloomMaxFilterSize(tde_nonce_size));
 
 	/*
 	 * round(log(2.0) * m / ndistinct), but assume round() may not be
@@ -479,7 +479,7 @@ brin_bloom_get_ndistinct(BrinDesc *bdesc, BloomOptions *opts)
 
 	Assert(BlockNumberIsValid(pagesPerRange));
 
-	maxtuples = MaxHeapTuplesPerPage * pagesPerRange;
+	maxtuples = MaxHeapTuplesPerPage(tde_nonce_size) * pagesPerRange;
 
 	/*
 	 * Similarly to n_distinct, negative values are relative - in this case to
diff --git a/src/backend/access/brin/brin_minmax_multi.c b/src/backend/access/brin/brin_minmax_multi.c
index bd14184d76..c17b0a6f83 100644
--- a/src/backend/access/brin/brin_minmax_multi.c
+++ b/src/backend/access/brin/brin_minmax_multi.c
@@ -1975,11 +1975,13 @@ brin_minmax_multi_distance_tid(PG_FUNCTION_ARGS)
 	 * We use the no-check variants here, because user-supplied values may
 	 * have (ip_posid == 0). See ItemPointerCompare.
 	 */
-	da1 = ItemPointerGetBlockNumberNoCheck(pa1) * MaxHeapTuplesPerPage +
-		ItemPointerGetOffsetNumberNoCheck(pa1);
+	da1 = ItemPointerGetBlockNumberNoCheck(pa1) *
+		  MaxHeapTuplesPerPage(tde_nonce_size) +
+		  ItemPointerGetOffsetNumberNoCheck(pa1);
 
-	da2 = ItemPointerGetBlockNumberNoCheck(pa2) * MaxHeapTuplesPerPage +
-		ItemPointerGetOffsetNumberNoCheck(pa2);
+	da2 = ItemPointerGetBlockNumberNoCheck(pa2) *
+		  MaxHeapTuplesPerPage(tde_nonce_size) +
+		  ItemPointerGetOffsetNumberNoCheck(pa2);
 
 	PG_RETURN_FLOAT8(da2 - da1);
 }
@@ -2451,7 +2453,7 @@ brin_minmax_multi_add_value(PG_FUNCTION_ARGS)
 		 * much lower, but meh.
 		 */
 		maxvalues = Min(target_maxvalues * MINMAX_BUFFER_FACTOR,
-						MaxHeapTuplesPerPage * pagesPerRange);
+						MaxHeapTuplesPerPage(tde_nonce_size) * pagesPerRange);
 
 		/* but always at least the original value */
 		maxvalues = Max(maxvalues, target_maxvalues);
@@ -2497,7 +2499,7 @@ brin_minmax_multi_add_value(PG_FUNCTION_ARGS)
 		 * much lower, but meh.
 		 */
 		maxvalues = Min(serialized->maxvalues * MINMAX_BUFFER_FACTOR,
-						MaxHeapTuplesPerPage * pagesPerRange);
+						MaxHeapTuplesPerPage(tde_nonce_size) * pagesPerRange);
 
 		/* but always at least the original value */
 		maxvalues = Max(maxvalues, serialized->maxvalues);
diff --git a/src/backend/access/brin/brin_pageops.c b/src/backend/access/brin/brin_pageops.c
index df9ffc2fb8..ac5d26f754 100644
--- a/src/backend/access/brin/brin_pageops.c
+++ b/src/backend/access/brin/brin_pageops.c
@@ -26,11 +26,10 @@
  * Maximum size of an entry in a BRIN_PAGETYPE_REGULAR page.  We can tolerate
  * a single item per page, unlike other index AMs.
  */
-#define BrinMaxItemSize \
+#define BrinMaxItemSize(tdeNonceSize) \
 	MAXALIGN_DOWN(BLCKSZ - \
-				  (MAXALIGN(SizeOfPageHeaderData + \
-							sizeof(ItemIdData)) + \
-				   MAXALIGN(sizeof(BrinSpecialSpace))))
+				  (MAXALIGN(SizeOfPageHeaderData + sizeof(ItemIdData)) + \
+				   MAXALIGN(sizeof(BrinSpecialSpace) + tdeNonceSize)))
 
 static Buffer brin_getinsertbuffer(Relation irel, Buffer oldbuf, Size itemsz,
 								   bool *extended);
@@ -69,12 +68,12 @@ brin_doupdate(Relation idxrel, BlockNumber pagesPerRange,
 	Assert(newsz == MAXALIGN(newsz));
 
 	/* If the item is oversized, don't bother. */
-	if (newsz > BrinMaxItemSize)
+	if (newsz > BrinMaxItemSize(tde_nonce_size))
 	{
 		ereport(ERROR,
 				(errcode(ERRCODE_PROGRAM_LIMIT_EXCEEDED),
 				 errmsg("index row size %zu exceeds maximum %zu for index \"%s\"",
-						newsz, BrinMaxItemSize, RelationGetRelationName(idxrel))));
+						newsz, BrinMaxItemSize(tde_nonce_size), RelationGetRelationName(idxrel))));
 		return false;			/* keep compiler quiet */
 	}
 
@@ -355,12 +354,12 @@ brin_doinsert(Relation idxrel, BlockNumber pagesPerRange,
 	Assert(itemsz == MAXALIGN(itemsz));
 
 	/* If the item is oversized, don't even bother. */
-	if (itemsz > BrinMaxItemSize)
+	if (itemsz > BrinMaxItemSize(tde_nonce_size))
 	{
 		ereport(ERROR,
 				(errcode(ERRCODE_PROGRAM_LIMIT_EXCEEDED),
 				 errmsg("index row size %zu exceeds maximum %zu for index \"%s\"",
-						itemsz, BrinMaxItemSize, RelationGetRelationName(idxrel))));
+						itemsz, BrinMaxItemSize(tde_nonce_size), RelationGetRelationName(idxrel))));
 		return InvalidOffsetNumber; /* keep compiler quiet */
 	}
 
@@ -692,7 +691,7 @@ brin_getinsertbuffer(Relation irel, Buffer oldbuf, Size itemsz,
 	Size		freespace;
 
 	/* callers must have checked */
-	Assert(itemsz <= BrinMaxItemSize);
+	Assert(itemsz <= BrinMaxItemSize(tde_nonce_size));
 
 	if (BufferIsValid(oldbuf))
 		oldblk = BufferGetBlockNumber(oldbuf);
@@ -805,7 +804,7 @@ brin_getinsertbuffer(Relation irel, Buffer oldbuf, Size itemsz,
 		 * page that has since been repurposed for the revmap.)
 		 */
 		freespace = *extended ?
-			BrinMaxItemSize : br_page_get_freespace(page);
+					BrinMaxItemSize(tde_nonce_size) : br_page_get_freespace(page);
 		if (freespace >= itemsz)
 		{
 			RelationSetTargetBlock(irel, newblk);
diff --git a/src/backend/access/brin/brin_revmap.c b/src/backend/access/brin/brin_revmap.c
index c574c8a06e..32423b3ea2 100644
--- a/src/backend/access/brin/brin_revmap.c
+++ b/src/backend/access/brin/brin_revmap.c
@@ -38,10 +38,10 @@
  * find the logical revmap page number and index number of the revmap item for
  * the given heap block number.
  */
-#define HEAPBLK_TO_REVMAP_BLK(pagesPerRange, heapBlk) \
-	((heapBlk / pagesPerRange) / REVMAP_PAGE_MAXITEMS)
-#define HEAPBLK_TO_REVMAP_INDEX(pagesPerRange, heapBlk) \
-	((heapBlk / pagesPerRange) % REVMAP_PAGE_MAXITEMS)
+#define HEAPBLK_TO_REVMAP_BLK(pagesPerRange, heapBlk, tdeNonceSize) \
+	((heapBlk / pagesPerRange) / REVMAP_PAGE_MAXITEMS(tdeNonceSize))
+#define HEAPBLK_TO_REVMAP_INDEX(pagesPerRange, heapBlk, tdeNonceSize) \
+	((heapBlk / pagesPerRange) % REVMAP_PAGE_MAXITEMS(tdeNonceSize))
 
 
 struct BrinRevmap
@@ -166,7 +166,7 @@ brinSetHeapBlockItemptr(Buffer buf, BlockNumber pagesPerRange,
 	page = BufferGetPage(buf);
 	contents = (RevmapContents *) PageGetContents(page);
 	iptr = (ItemPointerData *) contents->rm_tids;
-	iptr += HEAPBLK_TO_REVMAP_INDEX(pagesPerRange, heapBlk);
+	iptr += HEAPBLK_TO_REVMAP_INDEX(pagesPerRange, heapBlk, tde_nonce_size);
 
 	if (ItemPointerIsValid(&tid))
 		ItemPointerSet(iptr,
@@ -243,7 +243,8 @@ brinGetTupleForHeapBlock(BrinRevmap *revmap, BlockNumber heapBlk,
 		contents = (RevmapContents *)
 			PageGetContents(BufferGetPage(revmap->rm_currBuf));
 		iptr = contents->rm_tids;
-		iptr += HEAPBLK_TO_REVMAP_INDEX(revmap->rm_pagesPerRange, heapBlk);
+		iptr += HEAPBLK_TO_REVMAP_INDEX(revmap->rm_pagesPerRange, heapBlk,
+										tde_nonce_size);
 
 		if (!ItemPointerIsValid(iptr))
 		{
@@ -354,7 +355,8 @@ brinRevmapDesummarizeRange(Relation idxrel, BlockNumber heapBlk)
 	/* Lock the revmap page, obtain the index tuple pointer from it */
 	revmapBuf = brinLockRevmapPageForUpdate(revmap, heapBlk);
 	revmapPg = BufferGetPage(revmapBuf);
-	revmapOffset = HEAPBLK_TO_REVMAP_INDEX(revmap->rm_pagesPerRange, heapBlk);
+	revmapOffset = HEAPBLK_TO_REVMAP_INDEX(revmap->rm_pagesPerRange, heapBlk,
+										   tde_nonce_size);
 
 	contents = (RevmapContents *) PageGetContents(revmapPg);
 	iptr = contents->rm_tids;
@@ -454,7 +456,8 @@ revmap_get_blkno(BrinRevmap *revmap, BlockNumber heapBlk)
 	BlockNumber targetblk;
 
 	/* obtain revmap block number, skip 1 for metapage block */
-	targetblk = HEAPBLK_TO_REVMAP_BLK(revmap->rm_pagesPerRange, heapBlk) + 1;
+	targetblk = HEAPBLK_TO_REVMAP_BLK(revmap->rm_pagesPerRange, heapBlk,
+									  tde_nonce_size) + 1;
 
 	/* Normal case: the revmap page is already allocated */
 	if (targetblk <= revmap->rm_lastRevmapPage)
@@ -512,7 +515,8 @@ revmap_extend_and_get_blkno(BrinRevmap *revmap, BlockNumber heapBlk)
 	BlockNumber targetblk;
 
 	/* obtain revmap block number, skip 1 for metapage block */
-	targetblk = HEAPBLK_TO_REVMAP_BLK(revmap->rm_pagesPerRange, heapBlk) + 1;
+	targetblk = HEAPBLK_TO_REVMAP_BLK(revmap->rm_pagesPerRange, heapBlk,
+									  tde_nonce_size) + 1;
 
 	/* Extend the revmap, if necessary */
 	while (targetblk > revmap->rm_lastRevmapPage)
diff --git a/src/backend/access/brin/brin_tuple.c b/src/backend/access/brin/brin_tuple.c
index ee05372f79..74c366dc9a 100644
--- a/src/backend/access/brin/brin_tuple.c
+++ b/src/backend/access/brin/brin_tuple.c
@@ -217,7 +217,8 @@ brin_form_tuple(BrinDesc *brdesc, BlockNumber blkno, BrinMemTuple *tuple,
 			 * datatype, try to compress it in-line.
 			 */
 			if (!VARATT_IS_EXTENDED(DatumGetPointer(value)) &&
-				VARSIZE(DatumGetPointer(value)) > TOAST_INDEX_TARGET &&
+				VARSIZE(DatumGetPointer(value)) >
+				TOAST_INDEX_TARGET(tde_nonce_size) &&
 				(atttype->typstorage == TYPSTORAGE_EXTENDED ||
 				 atttype->typstorage == TYPSTORAGE_MAIN))
 			{
